% !TeX spellcheck = en_US
% !TeX encoding = UTF-8
% !TeX root = ../report.tex

\chapter{Guardian Angel Layer}
\label{chp:GuardianAngel}
In its current setup, the control of the gokart is subdivided into two parts. The \textit{Robot}, close to the hardware, providing a (ROS-) interface to the Robot's sensors and actuators and the \textit{Agent} interacting with the provided interfaces in order to perform higher-level tasks like localization, control, etc. As visible in~\Cref{fig:guardianAngel2} the Robot provides (sensor-) observations to the Agent which then returns (actuator-) commands.

\begin{figure}[htb]
\centering
% \subimport{tikz}{Guardian_Angel.tikz}
\input{tikz/Guardian_Angel.tex}
\caption{Guardian Angel, Agent and Robot interplay}
\label{fig:guardianAngel2}
\end{figure}

The Guardian Angel itself reads both - commands and observations, laying between the controller and the robot. Based on the received command(s) and a collection of previous measurements, the Guardian Angel decides whether to classify the current input(s) as safe. In case of an unsafe input, e.g., due to a rogue agent, the Guardian Angel intervenes and provides a set of safe commands until standstill.

The main idea of the Guardian Angel is \textbf{always to have a safe escape route or, otherwise, to take the least-worst trajectory}. Since we are operating in a non-static environment, a situation might occur where no collision-free escape route exists due to external factors (e.g., a human walking on the track, another agent, etc.). 

A further requirement is that the Guardian Angel works as a seamless layer in front of the robot - without altering the Agent (i.e., the controller). Thus it can be activated with any combination of Agent and Robot implementation, given that the control interface stays the same. The other way around, it needs to be removable without affecting the system in any way. That is the reason why we implemented the Guardian Angel as a separate layer that supervises the controller, instead of implementing the GA as a filter which~\cite{wabersich2018predictive} suggests.

The above-suggested concept is then extended further in \Cref{chp:ga_with_plan}. Instead of considering just the current command, we will incorporate the planned commands into evaluating the safety of a trajectory. 

\section{Dimensions of the Analysis}
\begin{itemize}
    \item \textbf{Information available} to the \ga: 
    \begin{itemize}
        \item Current state, (and previous states), extracted using a SLAM approach from the Lidar measurements. 
        \item Measurements from the Robot: steering wheel angle, pointcloud from Lidar, Accelerations from IMU, etc.
        \item Current Agent command: Current of both motors, torque of the steering wheel, brake position.
        \item (planned commands), once the Agent uses this interface it can communicate its planned commands.
    \end{itemize}
    \item \textbf{Conservativeness/invasiveness}: A measurement of how conservative or invasive respectiveley the Guardian Angel is.
    \item \textbf{Trusting the agent}: Development of some metrics quantifying how much to trust an agent.
\end{itemize}

